/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.*;
import java.net.Socket;

/**
 * クライアントセッションを管理
 * @author tondol
 */
public class ClientSession {
    private Socket socket = null;
    private BufferedReader reader = null;
    private PrintStream writer = null;
    String host; int port;
    
    public ClientSession() throws IOException {
        socket = new Socket(MainApp.option.host, MainApp.option.port);
        // 入力ストリームの文字コードを自動認識させる
        reader = new BufferedReader(new InputStreamReader(socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintStream(socket.getOutputStream());
        // サーバーから見たホスト名を取得
        host = reader.readLine();
        port = MainApp.option.port;
    }
    
    public void close() throws IOException {
        if (writer != null) writer.flush();
        if (socket != null) socket.close();
    }
    
    public void addItem(FileItem item) throws IOException {
        sendMessage("ADD " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    public void delItem(FileItem item) throws IOException {
        sendMessage("DEL " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    public String recvMessage() throws IOException {
        return reader.readLine();
    }
    
    public void sendMessage(String msg) {
        writer.println(msg);
        writer.flush();
    }
}
