/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.*;
import java.security.MessageDigest;

/**
 * ファイル情報を表すクラス
 * @author tondol
 */
public class FileItem {
    String name, path, hash, host;
    long size; int port;
    
    /**
     * Fileクラスから生成
     * @param file
     */
    public FileItem(File file) {
        name = file.getName();
        size = file.length();
        hash = getDigest(file);
        host = MainApp.client.host;
        port = MainApp.client.port;
        path = file.getPath();
    }
    
    /**
     * 文字列をデコード
     * @param info
     */
    public FileItem(String info) {
        String[] array = info.split("//", 5);
        name = array[0];
        size = Long.parseLong(array[1]);
        hash = array[2];
        host = array[3];
        port = Integer.parseInt(array[4]);
        path = null;
    }
    
    /**
     * FileクラスからMD5ハッシュを生成
     * @param file
     * @return 生成したハッシュ置
     */
    private String getDigest(File file) {
        // いろいろ準備
        FileInputStream inFile = null;
        MessageDigest digest = null;
        byte buf[] = new byte[65536];
        long remain, readSize;
        // ブロックごとにダイジェストを更新
        try {
            digest = MessageDigest.getInstance("MD5");
            inFile = new FileInputStream(file.getPath());
            remain = file.length();
            while (remain > 0) {
                readSize = inFile.read(buf, 0, 65536);
                if (readSize < 0) break;
                remain -= readSize;
                digest.update(buf);
            }
        } catch(Exception e) {
            ;
        } finally {
            try {
                if (inFile != null) inFile.close();
            } catch(IOException e) {
                ;
            }
        }
        // 文字列表現を取得
        buf = digest.digest();
        StringBuffer output= new StringBuffer();
        for (int i=0;i<buf.length;i++) {
            String b = Integer.toHexString(buf[i] & 0xff);
            if (b.length() == 1) output.append("0");
            output.append(b);
        }
        return output.toString();
    }
    
    /**
     * 中身の一致判定用
     */
    @Override public int hashCode() {
        return hash.hashCode();
    }
    @Override public boolean equals(Object obj) {
        if (getClass() != obj.getClass()) return false;
        FileItem other = (FileItem) obj;
        return this.hash.equals(other.hash);
    }
    
    /**
     * 文字列表現
     * @return エンコードした文字列
     */
    @Override public String toString() {
        return name + "//" + size + "//" +
               hash + "//" + host + "//" + port;
    }
}
