/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 * FileInfoをJTableで使うためのモデル
 * @author tondol
 */
public class FileItemTableModel extends AbstractTableModel {
    Vector<FileItem> items = new Vector<FileItem>();

    public void setItems(Vector<FileItem> items) {
        this.items = items;
        fireTableDataChanged();
    }
    
    public void clearItems() {
        items.clear();
        fireTableDataChanged();
    }
    
    public int getRowCount() {
        return items.size();
    }

    public int getColumnCount() {
        return 4;
    }
    
    @Override public String getColumnName(int column) {
        String values[] = { "ファイル名", "サイズ", "ハッシュ", "状態" };
        return values[column];
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        FileItem tmp = items.get(rowIndex);
        switch (columnIndex) {
            case 0: return tmp.name;
            case 1: return tmp.size;
            case 2: return tmp.hash;
            case 3: return "未対応";
            default: return null;
        }
    }
}
